<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKonsinyeUrun ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKonsinyeUrun
 * @subpackage Arrays
 */
class ArrayOfKonsinyeUrun extends AbstractStructArrayBase
{
    /**
     * The KonsinyeUrun
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\KonsinyeUrun[]
     */
    public $KonsinyeUrun;
    /**
     * Constructor method for ArrayOfKonsinyeUrun
     * @uses ArrayOfKonsinyeUrun::setKonsinyeUrun()
     * @param \StructType\KonsinyeUrun[] $konsinyeUrun
     */
    public function __construct(array $konsinyeUrun = array())
    {
        $this
            ->setKonsinyeUrun($konsinyeUrun);
    }
    /**
     * Get KonsinyeUrun value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\KonsinyeUrun[]|null
     */
    public function getKonsinyeUrun()
    {
        return isset($this->KonsinyeUrun) ? $this->KonsinyeUrun : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKonsinyeUrun method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKonsinyeUrun method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKonsinyeUrunForArrayConstraintsFromSetKonsinyeUrun(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKonsinyeUrunKonsinyeUrunItem) {
            // validation for constraint: itemType
            if (!$arrayOfKonsinyeUrunKonsinyeUrunItem instanceof \StructType\KonsinyeUrun) {
                $invalidValues[] = is_object($arrayOfKonsinyeUrunKonsinyeUrunItem) ? get_class($arrayOfKonsinyeUrunKonsinyeUrunItem) : sprintf('%s(%s)', gettype($arrayOfKonsinyeUrunKonsinyeUrunItem), var_export($arrayOfKonsinyeUrunKonsinyeUrunItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KonsinyeUrun property can only contain items of type \StructType\KonsinyeUrun, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KonsinyeUrun value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\KonsinyeUrun[] $konsinyeUrun
     * @return \ArrayType\ArrayOfKonsinyeUrun
     */
    public function setKonsinyeUrun(array $konsinyeUrun = array())
    {
        // validation for constraint: array
        if ('' !== ($konsinyeUrunArrayErrorMessage = self::validateKonsinyeUrunForArrayConstraintsFromSetKonsinyeUrun($konsinyeUrun))) {
            throw new \InvalidArgumentException($konsinyeUrunArrayErrorMessage, __LINE__);
        }
        if (is_null($konsinyeUrun) || (is_array($konsinyeUrun) && empty($konsinyeUrun))) {
            unset($this->KonsinyeUrun);
        } else {
            $this->KonsinyeUrun = $konsinyeUrun;
        }
        return $this;
    }
    /**
     * Add item to KonsinyeUrun value
     * @throws \InvalidArgumentException
     * @param \StructType\KonsinyeUrun $item
     * @return \ArrayType\ArrayOfKonsinyeUrun
     */
    public function addToKonsinyeUrun(\StructType\KonsinyeUrun $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KonsinyeUrun) {
            throw new \InvalidArgumentException(sprintf('The KonsinyeUrun property can only contain items of type \StructType\KonsinyeUrun, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KonsinyeUrun[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\KonsinyeUrun|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\KonsinyeUrun|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\KonsinyeUrun|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\KonsinyeUrun|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\KonsinyeUrun|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KonsinyeUrun
     */
    public function getAttributeName()
    {
        return 'KonsinyeUrun';
    }
}
