<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWebMagazaStok ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWebMagazaStok
 * @subpackage Arrays
 */
class ArrayOfWebMagazaStok extends AbstractStructArrayBase
{
    /**
     * The WebMagazaStok
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WebMagazaStok[]
     */
    public $WebMagazaStok;
    /**
     * Constructor method for ArrayOfWebMagazaStok
     * @uses ArrayOfWebMagazaStok::setWebMagazaStok()
     * @param \StructType\WebMagazaStok[] $webMagazaStok
     */
    public function __construct(array $webMagazaStok = array())
    {
        $this
            ->setWebMagazaStok($webMagazaStok);
    }
    /**
     * Get WebMagazaStok value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WebMagazaStok[]|null
     */
    public function getWebMagazaStok()
    {
        return isset($this->WebMagazaStok) ? $this->WebMagazaStok : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWebMagazaStok method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWebMagazaStok method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWebMagazaStokForArrayConstraintsFromSetWebMagazaStok(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWebMagazaStokWebMagazaStokItem) {
            // validation for constraint: itemType
            if (!$arrayOfWebMagazaStokWebMagazaStokItem instanceof \StructType\WebMagazaStok) {
                $invalidValues[] = is_object($arrayOfWebMagazaStokWebMagazaStokItem) ? get_class($arrayOfWebMagazaStokWebMagazaStokItem) : sprintf('%s(%s)', gettype($arrayOfWebMagazaStokWebMagazaStokItem), var_export($arrayOfWebMagazaStokWebMagazaStokItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WebMagazaStok property can only contain items of type \StructType\WebMagazaStok, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WebMagazaStok value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WebMagazaStok[] $webMagazaStok
     * @return \ArrayType\ArrayOfWebMagazaStok
     */
    public function setWebMagazaStok(array $webMagazaStok = array())
    {
        // validation for constraint: array
        if ('' !== ($webMagazaStokArrayErrorMessage = self::validateWebMagazaStokForArrayConstraintsFromSetWebMagazaStok($webMagazaStok))) {
            throw new \InvalidArgumentException($webMagazaStokArrayErrorMessage, __LINE__);
        }
        if (is_null($webMagazaStok) || (is_array($webMagazaStok) && empty($webMagazaStok))) {
            unset($this->WebMagazaStok);
        } else {
            $this->WebMagazaStok = $webMagazaStok;
        }
        return $this;
    }
    /**
     * Add item to WebMagazaStok value
     * @throws \InvalidArgumentException
     * @param \StructType\WebMagazaStok $item
     * @return \ArrayType\ArrayOfWebMagazaStok
     */
    public function addToWebMagazaStok(\StructType\WebMagazaStok $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WebMagazaStok) {
            throw new \InvalidArgumentException(sprintf('The WebMagazaStok property can only contain items of type \StructType\WebMagazaStok, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WebMagazaStok[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WebMagazaStok|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WebMagazaStok|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WebMagazaStok|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WebMagazaStok|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WebMagazaStok|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WebMagazaStok
     */
    public function getAttributeName()
    {
        return 'WebMagazaStok';
    }
}
